
/*
	Example file which uses pakked files

	(C) 1998 Richard Smithies  (richsmithies@hotmail.com)

	SELECT quits
*/


#define	PAKFILEADDR		0x80090000

#define	SCREENWIDTH		512
#define	SCREENHEIGHT	256

#define	MAXPRIMITIVES	1024
#define	OT_LENGTH		7

#define	NUMSPRITES		16

#include <libps.h>
#include "data.c"
#include "pak.h"
#include "pad.h"

void ReadController(u_char pad, u_short *dest);

GsOT		WorldOT[2];
GsOT_TAG	OTTags[2][1<<OT_LENGTH];
PACKET	GpuPacketArea[2][MAXPRIMITIVES*24];
volatile	u_char	*bb0,*bb1;
int		activebuff;
short		*sintab;

main()
{
	int	quitflag,hsyncs,f,xang,xang2,yang;
	u_short	paddata[4];
	GsSPRITE	spr[NUMSPRITES];

// Get address of sintable
	sintab = (short *)getpakaddress(_PAK_sintable_INDEX);

// Init sprites
	for (f=0;f<NUMSPRITES;f++)
	{
		spr[f].attribute = (1<<30) | (3<<28);
		spr[f].x = 0;
		spr[f].y = 0;
		spr[f].w = 32;
		spr[f].h = 32;
		spr[f].tpage = 512/64;
		spr[f].u = 0;
		spr[f].v = 0;
		spr[f].cx = 512;
		spr[f].cy = 240;
		spr[f].r = spr[f].g = spr[f].b = 128-f*(128/NUMSPRITES);
		spr[f].mx = spr[f].w/2;
		spr[f].my = spr[f].h/2;
		spr[f].scalex = spr[f].scaley = 4096;
		spr[f].rotate = 0;
	}
	spr[0].attribute = (1<<30) | (0<<28);

// Init PSX
	GetPadBuf(&bb0,&bb1);
	SetVideoMode(MODE_PAL);
	GsInitGraph(SCREENWIDTH,SCREENHEIGHT,4,0,0);
	GsDefDispBuff(0,0,0,256);
	GsInit3D();

	for (f=0;f<2;f++)
	{
		WorldOT[f].length = OT_LENGTH;
		WorldOT[f].org = OTTags[f];
	}

// Copy TIMs to frame buffer from PAK file
	TransferTIM(_PAK_shapetim_INDEX);
	TransferTIM(_PAK_backtim_INDEX);

	xang = 0; xang2 = 70;
	yang = 90;

	quitflag = 0;
	while (quitflag == 0)
	{
	// init frame
		activebuff = GsGetActiveBuff();
		GsSetWorkBase((PACKET *)GpuPacketArea[activebuff]);
		GsClearOt(0,0,&WorldOT[activebuff]);

	// check for quit (SELECT)
		ReadController(0,paddata);
		if (paddata[1] & PADselect)
			quitflag = 1;


	// move head sprite
		spr[0].x = sintab[xang]/400 + sintab[xang2]/400;
		spr[0].y = sintab[yang]/580;
		spr[0].rotate = sintab[xang2]*45;
		spr[0].scalex = 8192+sintab[xang]/8;
		spr[0].scaley = 8192+sintab[yang]/8;

	// update angles
		xang = (xang+3)%360;
		xang2 = (xang2+1)%360;
		yang = (yang+3)%360;

	// draw sprites
		for (f=0;f<NUMSPRITES;f++)
			GsSortSprite(&spr[f],&WorldOT[activebuff],1);

	// update tail sprites
		for (f=NUMSPRITES-1;f>0;f--)
		{
			spr[f].x = spr[f-1].x;
			spr[f].y = spr[f-1].y;
			spr[f].rotate = spr[f-1].rotate;
			spr[f].scalex = spr[f-1].scalex;
			spr[f].scaley = spr[f-1].scaley;
		}


	// tie up frame
		DrawSync(0);
		hsyncs = VSync(0);
		GsSwapDispBuff();
		{				// bodge in a background
			int g;
			RECT	r;
			r.x = 512; r.y = 256; r.w = 32; r.h = 32;
			for (g=0;g<(256/32);g++)
				for (f=0;f<(512/32);f++)
					MoveImage(&r,f*32,g*32+256*(1-activebuff));
			DrawSync(0);
		}
		GsDrawOt(&WorldOT[activebuff]);
	}

}

void ReadController(u_char pad, u_short *dest)
{ // pad is 0 for left, 1 for right. Dest is pointer to 8 bytes where info should go
	// reading from 2&3rd bytes of dest gives standard pad readout
	u_long	*pt;
	u_char	tmp;
	if (pad == 0)
		pt = (u_long *) bb0;
	else if (pad == 1)
		pt = (u_long *) bb1;
	*((u_long *)dest) = *pt;			// 1st 4 bytes
	*(((u_long *)dest)+1) = *(pt+1);		// 2nd 4 bytes
	*(((u_short *)dest)+1)=~(*(((u_short *)dest)+1));		// invert std controller
	tmp = *(((u_char *)dest)+2);
	*(((u_char *)dest)+2) = *(((u_char *)dest)+3);
	*(((u_char *)dest)+3) = tmp;
}
